import 'package:analyzer/dart/element/element.dart';
import 'package:build/build.dart';
import 'package:flutter_doc_annotation/flutter_doc_annotation.dart';
import 'package:flutter_doc_builder/src/library.dart';
import 'package:flutter_doc_builder/src/utils/types.dart';
import 'package:source_gen/source_gen.dart';

class FlutterDocGenerator extends GeneratorForAnnotation<Doc> {
  @override
  String generateForAnnotatedElement(
    Element element,
    ConstantReader annotation,
    BuildStep buildStep,
  ) {
    if (element is ClassElement && isWidget(element.allSupertypes)) {
      return generateLibrary(element);
    } else {
      throw InvalidGenerationSourceError(
        'Error, the decorated element is not a Widget',
        element: element,
      );
    }
  }
}
